diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/test/spectrum-interference-test.cc ns-3.36/src/spectrum/test/spectrum-interference-test.cc
--- ns-3.35/src/spectrum/test/spectrum-interference-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/test/spectrum-interference-test.cc	2022-04-30 18:23:58.150735000 -0700
@@ -34,19 +34,35 @@
 
 
 
+/**
+ * \ingroup spectrum-tests
+ *
+ * \brief Spectrum Interference Test
+ */
 class SpectrumInterferenceTestCase : public TestCase
 {
 public:
+  /**
+   * Constructor
+   * \param s Spectrum value
+   * \param txBytes number of bytes to transmit
+   * \param rxCorrect extected Rx bytes
+   * \param name test name
+   */
   SpectrumInterferenceTestCase (Ptr<SpectrumValue> s, uint32_t txBytes, bool rxCorrect, std::string name);
   virtual ~SpectrumInterferenceTestCase ();
   virtual void DoRun (void);
+  /**
+   * Retrieve the test results
+   * \param si SpectrumInterference instance
+   */
   void RetrieveTestResult (SpectrumInterference* si);
 
 private:
-  Ptr<SpectrumValue> m_s;
-  uint32_t m_txBytes;
-  uint32_t m_rxCorrectKnownOutcome;
-  Ptr<const SpectrumModel> m_mySpectrumModel;
+  Ptr<SpectrumValue> m_s;             //!< Spectrum value
+  uint32_t m_txBytes;                 //!< number of bytes to transmit
+  uint32_t m_rxCorrectKnownOutcome;   //!< extected Rx bytes
+  Ptr<const SpectrumModel> m_mySpectrumModel; //!< Spectrum model pointer
 };
 
 
@@ -130,6 +146,11 @@
 
 
 
+/**
+ * \ingroup spectrum-tests
+ *
+ * \brief Spectrum Interference TestSuite
+ */
 class SpectrumInterferenceTestSuite : public TestSuite
 {
 public:
@@ -191,4 +212,5 @@
 
 }
 
+/// Static variable for test initialization
 static SpectrumInterferenceTestSuite spectrumInterferenceTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/test/spectrum-test.h ns-3.36/src/spectrum/test/spectrum-test.h
--- ns-3.35/src/spectrum/test/spectrum-test.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/test/spectrum-test.h	2022-04-30 18:23:58.150735000 -0700
@@ -25,6 +25,14 @@
 
 
 /**
+ * \ingroup spectrum
+ * \defgroup spectrum-test Spectrum module tests
+ */
+
+
+/**
+ * \ingroup spectrum-tests
+ *
  * \brief Test if two SpectrumModel instances are equal within a given tolerance.
  *
  * This test compares component-by-component the two SpectrumModel
@@ -38,20 +46,16 @@
  *
  */
 #define NS_TEST_ASSERT_MSG_SPECTRUM_MODEL_EQ_TOL(actual, expected, tol, msg) \
-  NS_TEST_ASSERT_MSG_SPECTRUM_MODEL_EQ_TOL_INTERNAL (actual, expected, tol, msg, __FILE__, __LINE__)
-
-
-#define NS_TEST_ASSERT_MSG_SPECTRUM_MODEL_EQ_TOL_INTERNAL(actual, expected, tol, msg, file, line) \
-  do                                                                           \
-    {                                                                          \
-      Bands::const_iterator i = (actual).Begin ();                      \
-      Bands::const_iterator j = (expected).Begin ();                    \
-      uint32_t k = 0;                                                          \
-      while (i != (actual).End () && j != (expected).End ())            \
-        {                                                                      \
-          if ((i->fl > j->fl + (tol)) || (i->fl < j->fl - (tol))        \
-              || (i->fc > j->fc + (tol)) || (i->fc < j->fc - (tol))        \
-              || (i->fh > j->fh + (tol)) || (i->fh < j->fh - (tol)))       \
+  do                                                                         \
+    {                                                                        \
+      Bands::const_iterator i = (actual).Begin ();                           \
+      Bands::const_iterator j = (expected).Begin ();                         \
+      uint32_t k = 0;                                                        \
+      while (i != (actual).End () && j != (expected).End ())                 \
+        {                                                                    \
+          if ((i->fl > j->fl + (tol)) || (i->fl < j->fl - (tol))             \
+              || (i->fc > j->fc + (tol)) || (i->fc < j->fc - (tol))          \
+              || (i->fh > j->fh + (tol)) || (i->fh < j->fh - (tol)))         \
             {                                           \
               ASSERT_ON_FAILURE;                        \
               std::ostringstream indexStream;           \
@@ -63,7 +67,7 @@
               std::ostringstream expectedStream;        \
               expectedStream << j->fl << " <-- " << j->fc << " --> " << j->fh;          \
               ReportTestFailure (std::string (# actual) + indexStream.str () + " == " + std::string (# expected) + indexStream.str (),    \
-                                 actualStream.str (), expectedStream.str (), msgStream.str (), (file), (line)); \
+                                 actualStream.str (), expectedStream.str (), msgStream.str (), ( __FILE__), ( __LINE__)); \
               CONTINUE_ON_FAILURE;                                      \
             }                   \
           ++i;   \
@@ -79,13 +83,15 @@
           std::ostringstream expectedStream;        \
           expectedStream <<  (j != (expected).End ());              \
           ReportTestFailure ("Bands::iterator == End ()",                                  \
-                             actualStream.str (), expectedStream.str (), msgStream.str (), (file), (line)); \
+                             actualStream.str (), expectedStream.str (), msgStream.str (), ( __FILE__), ( __LINE__)); \
         } \
     }            \
   while (false); \
 
 
 /**
+ * \ingroup spectrum-tests
+ * 
  * \brief Test if two SpectrumValue instances are equal within a given tolerance.
  *
  * This test compares component-by-component the two SpectrumValue
@@ -99,12 +105,8 @@
  *
  */
 #define NS_TEST_ASSERT_MSG_SPECTRUM_VALUE_EQ_TOL(actual, expected, tol, msg) \
-  NS_TEST_ASSERT_MSG_SPECTRUM_VALUE_EQ_TOL_INTERNAL (actual, expected, tol, msg, __FILE__, __LINE__)
-
-
-#define NS_TEST_ASSERT_MSG_SPECTRUM_VALUE_EQ_TOL_INTERNAL(actual, expected, tol, msg, file, line) \
-  do                                                                           \
-    {                                                                          \
+  do                                                                         \
+    {                                                                        \
       Values::const_iterator i = (actual).ConstValuesBegin ();          \
       Values::const_iterator j = (expected).ConstValuesBegin ();        \
       uint32_t k = 0;                                                          \
@@ -122,7 +124,7 @@
               std::ostringstream expectedStream;        \
               expectedStream << expected;               \
               ReportTestFailure (std::string (# actual) + indexStream.str () + " == " + std::string (# expected) + indexStream.str (),    \
-                                 actualStream.str (), expectedStream.str (), msgStream.str (), file, line);     \
+                                 actualStream.str (), expectedStream.str (), msgStream.str (),  __FILE__,  __LINE__);     \
               CONTINUE_ON_FAILURE;                                      \
             }                   \
           ++i;   \
@@ -138,7 +140,7 @@
           std::ostringstream expectedStream;        \
           expectedStream <<  (j != (expected).ConstValuesEnd ());   \
           ReportTestFailure ("Values::const_iterator == ConstValuesEnd ()",                                        \
-                             actualStream.str (), expectedStream.str (), msgStream.str (), (file), (line)); \
+                             actualStream.str (), expectedStream.str (), msgStream.str (), ( __FILE__), ( __LINE__)); \
         } \
     }            \
   while (false); \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/test/spectrum-value-test.cc ns-3.36/src/spectrum/test/spectrum-value-test.cc
--- ns-3.35/src/spectrum/test/spectrum-value-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/test/spectrum-value-test.cc	2022-04-30 18:23:58.150735000 -0700
@@ -34,17 +34,35 @@
 
 #define TOLERANCE 1e-6
 
+/**
+ * \ingroup spectrum-tests
+ *
+ * \brief Spectrum Value Test
+ */
 class SpectrumValueTestCase : public TestCase
 {
 public:
+  /**
+   * Constructor
+   * \param a first SpectrumValue
+   * \param b second SpectrumValue
+   * \param name test name
+   */
   SpectrumValueTestCase (SpectrumValue a, SpectrumValue b, std::string name);
   virtual ~SpectrumValueTestCase ();
   virtual void DoRun (void);
 
 private:
+  /**
+   * Check that two SpectrumValue are equal withing a tolerance
+   * \param x first SpectrumValue
+   * \param y second SpectrumValue
+   * \return true if the two values are withing the tolerance
+   */
   bool MoreOrLessEqual (SpectrumValue x, SpectrumValue y);
-  SpectrumValue m_a;
-  SpectrumValue m_b;
+
+  SpectrumValue m_a; //!< first SpectrumValue
+  SpectrumValue m_b; //!< second SpectrumValue
 };
 
 
@@ -78,10 +96,11 @@
 
 
 
-
-
-
-
+/**
+ * \ingroup spectrum-tests
+ *
+ * \brief Spectrum Value TestSuite
+ */
 class SpectrumValueTestSuite : public TestSuite
 {
 public:
@@ -246,10 +265,11 @@
 
 
 
-
-
-
-
+/**
+ * \ingroup spectrum-tests
+ *
+ * \brief Spectrum Converter TestSuite
+ */
 class SpectrumConverterTestSuite : public TestSuite
 {
 public:
@@ -327,15 +347,11 @@
 //   NS_LOG_LOGIC(t21b);
 //   NS_LOG_LOGIC(*res);
   AddTestCase (new SpectrumValueTestCase (t21b, *res, ""), TestCase::QUICK);
-
-
 }
 
 
 
-
-
-
-// static instance of test suites
+/// Static variable for test initialization
 static SpectrumValueTestSuite g_SpectrumValueTestSuite;
+/// Static variable for test initialization
 static SpectrumConverterTestSuite g_SpectrumConverterTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/test/spectrum-waveform-generator-test.cc ns-3.36/src/spectrum/test/spectrum-waveform-generator-test.cc
--- ns-3.35/src/spectrum/test/spectrum-waveform-generator-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/test/spectrum-waveform-generator-test.cc	2022-04-30 18:23:58.150735000 -0700
@@ -28,20 +28,36 @@
 
 
 
+/**
+ * \ingroup spectrum-tests
+ *
+ * \brief Waveform generator Test
+ */
 class WaveformGeneratorTestCase : public TestCase
 {
 public:
+  /**
+   * Constructor
+   * 
+   * \param period waveform period (seconds)
+   * \param dutyCycle waveform duty cycle
+   * \param stop stop time (seconds)
+   */
   WaveformGeneratorTestCase (double period, double dutyCycle, double stop);
   virtual ~WaveformGeneratorTestCase ();
 
 private:
   virtual void DoRun (void);
 
+  /**
+   * Trace if the waveform is active
+   * \param newPkt unused.
+   */
   void    TraceWave (Ptr<const Packet> newPkt);
-  double  m_period;
-  double  m_dutyCycle;
-  double  m_stop;
-  int     m_fails;
+  double  m_period;     //!< waveform period (seconds)
+  double  m_dutyCycle;  //!< waveform duty cycle 
+  double  m_stop;       //!< stop time (seconds)
+  int     m_fails;      //!< failure check
 };
 
 void
@@ -101,6 +117,11 @@
 }
 
 
+/**
+ * \ingroup spectrum-tests
+ *
+ * \brief Waveform generator TestSuite
+ */
 class WaveformGeneratorTestSuite : public TestSuite
 {
 public:
@@ -118,4 +139,5 @@
   AddTestCase (new WaveformGeneratorTestCase (1.0, 0.5, 1.7), TestCase::QUICK);
 }
 
+/// Static variable for test initialization
 static WaveformGeneratorTestSuite g_waveformGeneratorTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/test/three-gpp-channel-test-suite.cc ns-3.36/src/spectrum/test/three-gpp-channel-test-suite.cc
--- ns-3.35/src/spectrum/test/three-gpp-channel-test-suite.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/test/three-gpp-channel-test-suite.cc	2022-04-30 18:23:58.150735000 -0700
@@ -41,6 +41,8 @@
 NS_LOG_COMPONENT_DEFINE ("ThreeGppChannelTestSuite");
 
 /**
+ * \ingroup spectrum-tests
+ *
  * Test case for the ThreeGppChannelModel class.
  * 1) check if the channel matrix has the correct dimensions
  * 2) check if the channel matrix is correctly normalized
@@ -207,6 +209,8 @@
 }
 
 /**
+ * \ingroup spectrum-tests
+ *
  * Test case for the ThreeGppChannelModel class.
  * It checks if the channel realizations are correctly updated during the
  * simulation.
@@ -346,6 +350,48 @@
 }
 
 /**
+ * \ingroup spectrum-tests
+ * \brief A structure that holds the parameters for the function
+ * CheckLongTermUpdate. In this way the problem with the limited
+ * number of parameters of method Schedule is avoided.
+ */
+struct CheckLongTermUpdateParams
+{
+  Ptr<ThreeGppSpectrumPropagationLossModel> lossModel; //!< the ThreeGppSpectrumPropagationLossModel object used to compute the rx PSD
+  Ptr<SpectrumValue> txPsd; //!< the PSD of the tx signal
+  Ptr<MobilityModel> txMob; //!< the mobility model of the tx device
+  Ptr<MobilityModel> rxMob; //!< the mobility model of the rx device
+  Ptr<SpectrumValue> rxPsdOld; //!< the previously received PSD
+  Ptr<PhasedArrayModel> txAntenna; //!< the antenna array of the tx device
+  Ptr<PhasedArrayModel> rxAntenna; //!< the antenna array of the rx device
+
+  /**
+   * \brief Constructor
+   * \param pLossModel the ThreeGppSpectrumPropagationLossModel object used to compute the rx PSD
+   * \param pTxPsd the PSD of the tx signal
+   * \param pTxMob the tx mobility model
+   * \param pRxMob the rx mobility model
+   * \param pRxPsdOld the previously received PSD
+   * \param pTxAntenna the tx antenna array
+   * \param pRxAntenna the rx antenna array
+   */
+  CheckLongTermUpdateParams (Ptr<ThreeGppSpectrumPropagationLossModel> pLossModel, Ptr<SpectrumValue> pTxPsd,
+                             Ptr<MobilityModel> pTxMob, Ptr<MobilityModel> pRxMob, Ptr<SpectrumValue> pRxPsdOld,
+                             Ptr<PhasedArrayModel> pTxAntenna, Ptr<PhasedArrayModel> pRxAntenna)
+  {
+    lossModel = pLossModel;
+    txPsd = pTxPsd;
+    txMob = pTxMob;
+    rxMob = pRxMob;
+    rxPsdOld = pRxPsdOld;
+    txAntenna = pTxAntenna;
+    rxAntenna = pRxAntenna;
+  }
+};
+
+/**
+ * \ingroup spectrum-tests
+ * 
  * Test case for the ThreeGppSpectrumPropagationLossModelTest class.
  * 1) checks if the long term components for the direct and the reverse link
  *    are the same
@@ -384,14 +430,9 @@
   /**
    * Test of the long term component is correctly updated when the channel
    * matrix is recomputed
-   * \param lossModel the ThreeGppSpectrumPropagationLossModel object used to
-   *        compute the rx PSD
-   * \param txPsd the PSD of the transmitted signal
-   * \param txMob the mobility model of the tx device
-   * \param rxMob the mobility model of the rx device
-   * \param rxPsdOld the previously received PSD
+   * \param params a structure that contains the set of parameters needed by CheckLongTermUpdate in order to perform calculations
    */
-  void CheckLongTermUpdate (Ptr<ThreeGppSpectrumPropagationLossModel> lossModel, Ptr<SpectrumValue> txPsd, Ptr<MobilityModel> txMob, Ptr<MobilityModel> rxMob, Ptr<SpectrumValue> rxPsdOld);
+  void CheckLongTermUpdate (CheckLongTermUpdateParams &params);
 
   /**
    * Checks if two PSDs are equal
@@ -440,10 +481,10 @@
 }
 
 void
-ThreeGppSpectrumPropagationLossModelTest::CheckLongTermUpdate (Ptr<ThreeGppSpectrumPropagationLossModel> lossModel, Ptr<SpectrumValue> txPsd, Ptr<MobilityModel> txMob, Ptr<MobilityModel> rxMob, Ptr<SpectrumValue> rxPsdOld)
+ThreeGppSpectrumPropagationLossModelTest::CheckLongTermUpdate (CheckLongTermUpdateParams &params)
 {
-  Ptr<SpectrumValue> rxPsdNew = lossModel->DoCalcRxPowerSpectralDensity (txPsd, txMob, rxMob);
-  NS_TEST_ASSERT_MSG_EQ (ArePsdEqual (rxPsdOld, rxPsdNew),  false, "The long term is not updated when the channel matrix is recomputed");
+  Ptr<SpectrumValue> rxPsdNew = params.lossModel->DoCalcRxPowerSpectralDensity (params.txPsd, params.txMob, params.rxMob, params.txAntenna, params.rxAntenna);
+  NS_TEST_ASSERT_MSG_EQ (ArePsdEqual (params.rxPsdOld, rxPsdNew),  false, "The long term is not updated when the channel matrix is recomputed");
 }
 
 void
@@ -498,10 +539,6 @@
                                                                                     "NumRows", UintegerValue (rxAntennaElements [1]),
                                                                                     "AntennaElement", PointerValue(CreateObject<IsotropicAntennaModel> ()));
   
-  // initialize ThreeGppSpectrumPropagationLossModel
-  lossModel->AddDevice (txDev, txAntenna);
-  lossModel->AddDevice (rxDev, rxAntenna);
-
   // set the beamforming vectors
   DoBeamforming (txDev, txAntenna, rxDev, rxAntenna);
   DoBeamforming (rxDev, rxAntenna, txDev, txAntenna);
@@ -513,10 +550,10 @@
   Ptr<SpectrumValue> txPsd =  sf.CreateTxPowerSpectralDensity (txPower, channelNumber);
 
   // compute the rx psd
-  Ptr<SpectrumValue> rxPsdOld = lossModel->DoCalcRxPowerSpectralDensity (txPsd, txMob, rxMob);
+  Ptr<SpectrumValue> rxPsdOld = lossModel->DoCalcRxPowerSpectralDensity (txPsd, txMob, rxMob, txAntenna, rxAntenna);
 
   // 1) check that the rx PSD is equal for both the direct and the reverse channel
-  Ptr<SpectrumValue> rxPsdNew = lossModel->DoCalcRxPowerSpectralDensity (txPsd, rxMob, txMob);
+  Ptr<SpectrumValue> rxPsdNew = lossModel->DoCalcRxPowerSpectralDensity (txPsd, rxMob, txMob, rxAntenna, txAntenna);
   NS_TEST_ASSERT_MSG_EQ (ArePsdEqual (rxPsdOld, rxPsdNew),  true, "The long term for the direct and the reverse channel are different");
 
   // 2) check if the long term is updated when changing the BF vector
@@ -526,7 +563,7 @@
   txBfVector [0] = std::complex<double> (0.0, 0.0);
   txAntenna->SetBeamformingVector (txBfVector);
 
-  rxPsdNew = lossModel->DoCalcRxPowerSpectralDensity (txPsd, rxMob, txMob);
+  rxPsdNew = lossModel->DoCalcRxPowerSpectralDensity (txPsd, rxMob, txMob, rxAntenna, txAntenna);
   NS_TEST_ASSERT_MSG_EQ (ArePsdEqual (rxPsdOld, rxPsdNew),  false, "Changing the BF vectors the rx PSD does not change");
 
   // update rxPsdOld
@@ -534,14 +571,14 @@
 
   // 3) check if the long term is updated when the channel matrix is recomputed
   Simulator::Schedule (MilliSeconds (101), &ThreeGppSpectrumPropagationLossModelTest::CheckLongTermUpdate,
-                       this, lossModel, txPsd, txMob, rxMob, rxPsdOld);
+                       this, CheckLongTermUpdateParams (lossModel, txPsd, txMob, rxMob, rxPsdOld, txAntenna, rxAntenna));
 
   Simulator::Run ();
   Simulator::Destroy ();
 }
 
 /**
- * \ingroup spectrum
+ * \ingroup spectrum-tests
  *
  * Test suite for the ThreeGppChannelModel class
  */
@@ -562,4 +599,5 @@
   AddTestCase (new ThreeGppSpectrumPropagationLossModelTest, TestCase::QUICK);
 }
 
+/// Static variable for test initialization
 static ThreeGppChannelTestSuite myTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/test/tv-helper-distribution-test.cc ns-3.36/src/spectrum/test/tv-helper-distribution-test.cc
--- ns-3.35/src/spectrum/test/tv-helper-distribution-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/test/tv-helper-distribution-test.cc	2022-04-30 18:23:58.150735000 -0700
@@ -22,7 +22,13 @@
 #include <ns3/log.h>
 #include <ns3/tv-spectrum-transmitter-helper.h>
 
+NS_LOG_COMPONENT_DEFINE ("TvHelperDistributionTest");
+
+using namespace ns3;
+
 /**
+ * \ingroup spectrum-tests
+ * 
  * This test verifies the accuracy of the private GetRandomNumTransmitters()  
  * method in the TvSpectrumTransmitterHelper class. The method generates a 
  * random number corresponding to the number of TV transmitters to create based 
@@ -40,21 +46,26 @@
  * 41 and 60 transmitters can be created (all inclusive). This is tested with 
  * various cases.
  */
-NS_LOG_COMPONENT_DEFINE ("TvHelperDistributionTest");
-
-using namespace ns3;
-
-
 class TvHelperDistributionTestCase : public TestCase
 {
 public:
+  /**
+   * Constructor
+   * 
+   * \param maxNumTransmitters maximum number of transmitters.
+   */
   TvHelperDistributionTestCase (uint32_t maxNumTransmitters);
   virtual ~TvHelperDistributionTestCase ();
 
 private:
   virtual void DoRun (void);
+  /**
+   * Build the test name
+   * \param maxNumTransmitters maximum number of transmitters.
+   * \return The test name
+   */
   static std::string Name (uint32_t maxNumTransmitters);
-  uint32_t m_maxNumTransmitters;
+  uint32_t m_maxNumTransmitters;  //!< Maximum number of transmitters.
 };
 
 std::string 
@@ -120,6 +131,11 @@
 }
 
 
+/**
+ * \ingroup spectrum-tests
+ *
+ * Test suite for the TvSpectrumTransmitterHelper class
+ */
 class TvHelperDistributionTestSuite : public TestSuite
 {
 public:
@@ -137,4 +153,5 @@
     }
 }
 
+/// Static variable for test initialization
 static TvHelperDistributionTestSuite g_TvHelperDistributionTestSuite;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/spectrum/test/tv-spectrum-transmitter-test.cc ns-3.36/src/spectrum/test/tv-spectrum-transmitter-test.cc
--- ns-3.35/src/spectrum/test/tv-spectrum-transmitter-test.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/spectrum/test/tv-spectrum-transmitter-test.cc	2022-04-30 18:23:58.150735000 -0700
@@ -25,13 +25,6 @@
 #include <ns3/double.h>
 #include <ns3/tv-spectrum-transmitter.h>
 
-/**
- * This test verifies the accuracy of the spectrum/PSD model in the 
- * TvSpectrumTransmitter class. To do so, it tests if the max power spectral 
- * density, start frequency, and end frequency comply with expected values. 
- * Values for TV/modulation type, start frequency, channel bandwidth, and 
- * base PSD are swept and tested for each case.
- */
 NS_LOG_COMPONENT_DEFINE ("TvSpectrumTransmitterTest");
 
 using namespace ns3;
@@ -41,9 +34,25 @@
 //           Follows http://realtimecollisiondetection.net/blog/?p=89
 double epsilon;
 
+/**
+ * \ingroup spectrum-tests
+ *
+ * This test verifies the accuracy of the spectrum/PSD model in the 
+ * TvSpectrumTransmitter class. To do so, it tests if the max power spectral 
+ * density, start frequency, and end frequency comply with expected values. 
+ * Values for TV/modulation type, start frequency, channel bandwidth, and 
+ * base PSD are swept and tested for each case.
+ */
 class TvSpectrumTransmitterTestCase : public TestCase
 {
 public:
+  /**
+   * Constructor
+   * \param startFrequency Start frequency.
+   * \param channelBandwidth Channel Bandwidth.
+   * \param basePsd Base Power Spectral Density (PSD).
+   * \param tvType TV type.
+   */
   TvSpectrumTransmitterTestCase (double startFrequency, 
                             double channelBandwidth, 
                             double basePsd, 
@@ -52,15 +61,23 @@
 
 private:
   virtual void DoRun (void);
+  /**
+   * Build the test name
+   * \param tvType TV type.
+   * \param startFrequency Start frequency.
+   * \param channelBandwidth Channel Bandwidth.
+   * \param basePsd Base Power Spectral Density (PSD).
+   * \return The test name
+   */
   static std::string Name (TvSpectrumTransmitter::TvType tvType, 
                            double startFrequency, 
                            double channelBandwidth, 
                            double basePsd);
 
-  double m_startFrequency;
-  double m_channelBandwidth; 
-  double m_basePsd;
-  TvSpectrumTransmitter::TvType m_tvType;
+  double m_startFrequency;      //!< Start frequency.
+  double m_channelBandwidth;    //!< Channel Bandwidth.
+  double m_basePsd;             //!< Base Power Spectral Density (PSD).
+  TvSpectrumTransmitter::TvType m_tvType; //!< TV type.
 };
 
 
@@ -154,6 +171,11 @@
 }
 
 
+/**
+ * \ingroup spectrum-tests
+ *
+ * Test suite for the TvSpectrumTransmitter class
+ */
 class TvSpectrumTransmitterTestSuite : public TestSuite
 {
 public:
@@ -208,4 +230,5 @@
     }
 }
 
+/// Static variable for test initialization
 static TvSpectrumTransmitterTestSuite g_tvSpectrumTransmitterTestSuite;
